 ///////////////////////////////////////////
var video_mode = 8;
var video_depth = 32;
///////////////////////////////////////////
path "bilder";
path "sounds";
path "models";
path "player";

////////////////////////////////////////////
string mini_wmb = <mini.wmb>;
bmap score_bmp = <scoreboard.tga>;
bmap star = <star.tga>;
font live_font = "Base 02", 0, 100;
font score_font = "Base 02", 0, 80;
font cheat_font = "Base 02", 0, 20;
font name_font = "Base 02", 0, 85;
font game_over_font = "Base 02", 0, 200;
font created_by_font = "Base 02", 0, 150;
font credits_font = "Base 02", 0, 60;
sound plop1 = <plop.wav>;
string cheat_str[50];
entity* player;
sound cheat_active = <active.wav>;
sound explosion = <explosion.wav>;
bmap left_bmp = <left2.tga>;
bmap middle_bmp = <middle3.tga>;
bmap right_bmp = <right2.tga>;
bmap funke = <funke.bmp>;
bmap heart_bmp = <heart.tga>;
bmap smoke_bmp = <smoke.tga>;
bmap black_bmp = <black.bmp>;
string playername[8];
bmap submit_bmp = <name.tga>;
bmap submit_button = <submit.tga>;
bmap submit_button_over = <submit_over.tga>;
bmap submit_button_on = <submit_on.tga>;
bmap abort_bmp = <abort.tga>;
bmap cursor = <cursor.tga>;
sound groll = <groll.wav>;
bmap window_flash = <window_flash2.tga>;
sound boing1 = <boing1.wav>;
sound boing2 = <boing2.wav>;
sound ring = <ring.wav>;
sound baad = <baaad.wav>;
bmap button_map = <button.tga>;
bmap button_on_map = <button_on.tga>;
bmap button_over_map = <button_over.tga>;
sound big = <big.wav>;
sound small =<small.wav>;
bmap help = <help.png>;
bmap help_on = <help_on.png>;
bmap shademap = <shademap3.bmp>;

////////////////////////////////////////////
//values
var level_nr = 1;
var score_points = 0;
var cheat_activ = 0;
var show_live = 126;
var lives = 3;
var physikobject = 0;
var earth_gravity[3] = 0,0, -386;
var laser_on = 0;
var pause = 0;
var gameover = 0;
var dll_handle;
var PostString;
var ResultString;
var cheater = 0;
var menue = 0;
var mouse_speed = 60;
var player_size = 0;
var inverse = 1;
var bg_sound_handle;
var bg_heartbeat;
var rain=0;
var create_pos[3];//for the rain
var file_handle;
var bonus_level;
var mute_vol;

var level_max;
var points_max;

////////////////////////////////////////////

define position,skill5;

dllfunction HTTP_Create(id);
dllfunction HTTP_Get(id,url_str);
dllfunction HTTP_Post(id,url_str,data_str);
dllfunction HTTP_PostFile(id,url_str,file_str,var_str); 
dllfunction HTTP_PostFile2(id,url_str,file_str); 
dllfunction HTTP_Abort(id);
dllfunction HTTP_IsWorking(id);
dllfunction HTTP_Results(id,results_str);
dllfunction HTTP_SaveToFile(id,filename_str); 
dllfunction HTTP_Free(id);

dllfunction DllOpenInternet(website);

material mtl_toon
{
	skin1=shademap;
	effect="new_try.fx";
}

///////////////////
//  P A N E L S  //
///////////////////
function submit_fun();
function show_credits();
function visit_info();

panel score_pan
{
	bmap = score_bmp;
	flags = visible,transparent;
	alpha = 0;
	pos_x = -20;
	pos_Y = -20;
	red = 122;
	green = 0;
	blue = 0;
	digits 110,60,11,score_font,1,score_points;
	digits 130,150,-5.3,live_font,1,level_nr;
}

text cheat_txt
{
	pos_x = 10;
	pos_y = 0;
	string = cheat_str;
	font = cheat_font;
	red = 122;
	green = 0;
	blue = 0;
	flags = visible;
}

panel health_pan1
{
	pos_x = 10;
	pos_y = 10;
	bmap = left_bmp;
	flags = visible,transparent;
	alpha = 0;
}

panel health_pan2
{
	pos_x = 100;
	pos_y = 20;
	flags = visible,transparent;
	window = 0,0,315,40,middle_bmp,show_live,0;
	alpha = 0;
}

panel health_pan3
{
	pos_x = 200;
	pos_y = 10;
	bmap = right_bmp;
	flags = visible,transparent;
	alpha = 0;
}

text game_over_txt
{
	layer = 3;
	string = "Game Over";
	font = game_over_font;
	red = 122;
	green = 0;
	blue = 0;
}

panel black_pan
{
	layer = 2;
	bmap = black_bmp;
	scale_x = 128;
	scale_y = 128;
	alpha = 0;
	flags = visible, transparent;
}

panel black_pan2
{
	layer = 6;
	bmap = black_bmp;
	scale_x = 128;
	scale_y = 128;
}

panel submit_pan
{
	layer = 4;
	bmap = submit_bmp;
	alpha = 0;
	flags = transparent;
}

panel submit_button_pan
{
	layer = 5;
	alpha = 0;
	flags = transparent;
	button = 0,0,submit_button_on,submit_button,submit_button_over,submit_fun,null,null;
}

text submit_name_txt
{
	pos_x = 90;
	pos_y = 68;
	layer=5;
	string = playername;
	alpha = 0;
	flags = transparent;
	font = name_font;
	red = 122;
	green = 0;
	blue = 0;
}

panel abort_pan {
	layer=7;
	bmap = abort_bmp;
}

text created_by_txt
{
	pos_x = 20;
	layer=10;
	font = created_by_font;
	red = 122;
	green = 0;
	blue = 0;
	flags = visible,transparent;
	alpha = 0;
	string = "created by:\n\nKai A. Hiller";
}

panel window_flash_pan
{
	bmap = window_flash;
	flags=light;
	red = 0;
	green = 0;
	blue = 0;
}

function start_game
{
	menue=0;
	pause=0;
}

function exit_game
{
	var volume=100;
	while(volume>0)
	{
		media_tune(bg_sound_handle,volume,0,0);
		volume-=5*time;
		wait(1);
	}
	sys_exit("");
}

panel menue_pan
{
	button 0,0,button_on_map,button_map,button_over_map,start_game,null,null;
	button 50,200,button_on_map,button_map,button_over_map,show_credits,null,null;
	button 100,400,button_on_map,button_map,button_over_map,exit_game,null,null;
	layer=20;
	flags=transparent;
	alpha=0;
}

text menue_ng_txt
{
	pos_y = 30;
	layer=19;
	string="New Game";
	font = score_font;
	flags=transparent;
	alpha=0;
}

text menue_resume_txt
{
	pos_y = 30;
	layer=19;
	string="Resume";
	font = score_font;
	flags=transparent;
	alpha=0;
}

text show_credits_txt
{
	pos_y = 230;
	layer=19;
	string="Credits";
	font = score_font;
	flags=transparent;
	alpha=0;
}

text Exit_txt
{
	pos_y = 430;
	layer=19;
	string="Exit !";
	font = score_font;
	flags=transparent;
	alpha=0;
}

panel help_pan
{
	layer=19;
	bmap = help;
	flags=transparent;
	alpha=0;
	button=0,0,help_on,help,help_on,visit_info,null,null;
}

text credits_txt
{
	layer = 19;
	font = credits_font;
	string="
  Thanks to:\n
     ambe for the great panels
TripleX for his \"BIG\"-plugin
  Peacemaker for his GSHTTP.dll
http://www.grsites.com for the heartbeat
  and godfather 4 the shader tutorial\n
Thank you guys, with your
 help my game became a
  lot better =)";
	red = 122;
	green = 0;
	blue = 0;
	flags=transparent;
	alpha=0;
}

function show_credits
{
	var old_menue;
	old_menue = menue;
	menue=3;
	mouse_mode = 0;
	credits_txt.visible = on;
	menue_pan.transparent = on;
	menue_ng_txt.transparent = on;
	menue_resume_txt.transparent = on;
	show_credits_txt.transparent = on;
	Exit_txt.transparent = on;
	while(menue_pan.alpha>0)
	{
		menue_pan.alpha -= 5*time;
		if(old_menue==2)
		{
			menue_ng_txt.alpha -= 5*time;
		}
		else//menue was 
		{
			menue_resume_txt.alpha -= 5*time;
		}
		show_credits_txt.alpha -= 5*time;
		Exit_txt.alpha -= 5*time;
		help_pan.alpha -= 5*time;
		credits_txt.alpha += 5*time;
		black_pan.alpha += 5*time;
		wait(1);
	}
	credits_txt.transparent = off;
	menue_pan.visible = off;
	menue_ng_txt.visible = off;
	menue_resume_txt.visible = off;
	show_credits_txt.visible = off;
	Exit_txt.visible = off;
	help_pan.visible = off;
	while(key_any==0){wait(1);}
	credits_txt.transparent = on;
	menue_pan.visible = on;
	menue_ng_txt.visible = on;
	menue_resume_txt.visible = on;
	show_credits_txt.visible = on;
	Exit_txt.visible = on;
	help_pan.visible = on;
	while(menue_pan.alpha<100)
	{
		menue_pan.alpha += 5*time;
		if(old_menue==2)
		{
			menue_ng_txt.alpha += 5*time;
		}
		else//menue was 
		{
			menue_resume_txt.alpha += 5*time;
		}
		show_credits_txt.alpha += 5*time;
		Exit_txt.alpha += 5*time;
		help_pan.alpha += 5*time;
		credits_txt.alpha -= 5*time;
		black_pan.alpha -= 5*time;
		wait(1);
	}
	menue_pan.transparent = off;
	if(old_menue==2)
	{
		menue_ng_txt.transparent = off;
	}
	else
	{
		menue_resume_txt.transparent = off;
	}
	show_credits_txt.transparent = off;
	Exit_txt.transparent = off;
	menue = old_menue;
	mouse_mode = 2;
}
/////////////////////////////////////////////////////////////////////////////
//MAIN MAIN MAIN MAIN MY MAIN MAIN MY MUM MAIN MY MAMUT MAIN MAIN MAIN...  //
/////////////////////////////////////////////////////////////////////////////
sound heartbeat = <medical005.wav>;

function main
{
	randomize();
	mouse_pointer = 0;
	level_load (mini_wmb);
	if(sys_metrics(0)>=1280)
	{
		video_switch(9,0,1);
	}
	else
	{
		video_switch(8,0,1);
	}
	window_ctrl();
	panel_position();
	game_loop();
	make_it4shader();
	bg_sound_handle=media_loop("blue_skies.mp3",null,100);
	bg_heartbeat=snd_loop(heartbeat,100,0);
	snd_tune(bg_heartbeat,1,0,0);
	mouse_map = cursor;
	wait(3);
	camera.tilt -= 90;
	while(created_by_txt.alpha < 100)
	{
		created_by_txt.alpha += 10*time;
		wait(1);
	}
	sleep(3);
	while(created_by_txt.alpha > 0)
	{
		created_by_txt.alpha -= 10*time;
		created_by_txt.pos_x += total_ticks/5;
		wait(1);
	}
	control_menue();
	menue = 2;
	while(menue>0){wait(1);}
	mouse_mode = 0;
	while(score_pan.alpha < 100)
	{
		score_pan.alpha += 5*time;
		health_pan1.alpha += 5*time;
		health_pan2.alpha += 5*time;
		health_pan3.alpha += 5*time;
		wait(1);
	}
	score_pan.transparent = off;
	health_pan1.transparent = off;
	health_pan2.transparent = off;
	health_pan3.transparent = off;
	menue_pan.visible = off;
	menue_ng_txt.visible = off;
	show_credits_txt.visible = off;
	Exit_txt.visible = off;
	sleep(1);
	while(camera.z < 1500)
	{
		camera.z += 50*time;
		wait(1);
	}
	pause = 0;
	control_health();
	generate_blocks();
	letitrain();
	ph_setgravity ( earth_gravity );
	//mouse_pointer = 0;
}

function restart
{
	my=null;
	reset_panels();
	reset_values();
	mouse_pointer = 0;
	menue = 2;
	if(bonus_level==1)
	{
		level_load ("bonus1.wmb");
	}
	else
	{
		level_load (mini_wmb);
	}
	wait(3);
	control_health();
	camera.tilt = -90;
	while(menue>0){wait(1);}
	score_pan.visible = on;
	health_pan1.visible = on;
	health_pan2.visible = on;
	health_pan3.visible = on;
	while(score_pan.alpha < 100)
	{
		score_pan.alpha += 5*time;
		health_pan1.alpha += 5*time;
		health_pan2.alpha += 5*time;
		health_pan3.alpha += 5*time;
		wait(1);
	}
	score_pan.transparent = off;
	health_pan1.transparent = off;
	health_pan2.transparent = off;
	health_pan3.transparent = off;
	sleep(1);
	while(camera.z < 1500)
	{
		camera.z += 50*time;
		wait(1);
	}
	generate_blocks();
	letitrain();
	mouse_pointer = 0;
}

function game_loop
{
	while(1)
	{
		if(!pause)
		{
			level_nr += 0.005*time;
			if(key_ctrl&&key_alt&&key_c)
			{
				cheat();
			}
		}
		/*if(score_points > 250 || level_nr > 7)
		{
			error("Das ist nur die Demo version mit begrenzter Spielzeit\nin der Vollversion gibt es unbegrenzte Spielzeit, eine Internethighscore und viel mehr Bloxx und Cheats");
			exit;
		}*/
		MOUSE_POS.X += mickey.x;
		MOUSE_POS.Y += mickey.y;
		mouse_speed = clamp(mouse_speed+mickey.z/30,30,150);
		wait(1);
	}
}
////////////////////////////////////////
//  G E N A R A L  F U N C T I O N S  //
////////////////////////////////////////
function get_standart_part();
function box_normal();
function superbox();
function bomb();
function bomb_burn();
function heart();
function smoke();
function bounce_ball();
function color_block();
function good_point();
function bad_point();
function death_block();
function flash_panel(color);
function glimmer();
function diamond();
function bigger();
function smaller();
function player_bigger();
function blitz_block();

function activate_laser(duration)
{
	proc_kill(4);
	me=null;
	snd_play(cheat_active,100,0);
	laser_on = 1;
	wait(-duration);
	laser_on = 0;
}

function rain_cycle(&create_pos,create_size)
{
	me = ent_create("wave.tga",create_pos,null);
	my.oriented = on;
	my.tilt = 90;
	my.passable = on;
	my.unlit = on;
	my.ambient = 100;
	my.scale_x = create_size;
	my.scale_y = create_size;
	my.z += create_size;
	my.transparent = on;
	my.alpha = 0;
	while(my.alpha<40)
	{
		my.scale_x += 0.012*time;
		my.scale_y += 0.012*time;
		my.alpha += 2*time;
		wait(1);
	}
	while(my.alpha>0)
	{
		my.scale_x += 0.012*time;
		my.scale_y += 0.012*time;
		my.alpha -= 2*time;
		wait(1);
	}
	ent_remove(me);
}

function letitrain
{
	me = player;
	while(1)
	{
		if(rain)
		{
			vec_set(create_pos,vector(200-random(400),200-random(400),335));
			rain_cycle(create_pos,0.125);
			wait(-1);
			rain_cycle(create_pos,0.125);
			wait(-1);
			rain_cycle(create_pos,0.125);
		}
		wait(-random(2));
	}
}

function cheat
{
	if(cheat_activ != 0||menue!=0){return;}
	str_cpy(cheat_Str,"              ");
	inkey(cheat_str);
	if(str_to_num(cheat_str) != 0)
	{
		temp = str_to_num(cheat_str);
		if(temp>-1)
		{
			snd_play(cheat_active,100,0);
			score_points = temp;
			cheater = 1;
		}
		else
		{
			str_cpy(cheat_str,"the number was too big or < 0");
		}
	}
	if(str_cmpi(cheat_str,"wsad"))
	{
		cheat_activ = 1;
		cheater = 1;
		snd_play(cheat_active,100,0);
		sleep(8);
		cheat_activ = 0;
	}
	if(str_cmpi(cheat_str,"they are coming"))
	{
		cheater = 1;
		activate_laser(50);
	}
	if(str_cmpi(cheat_str,"game over"))
	{
		lives = 0;
	}
	if(str_cmpi(cheat_str,"water rain"))
	{
		rain = (rain==0);
	}
}

function generate_blocks() 
{
	me=player;
	var generate;
   while (1) 
   {
		if(!pause && !freeze_mode)
		{
			if(cheat_activ == 0)
			{
				temp.y = camera.x + (200-(random(400)));
				temp.x = camera.y + (200-(random(400)));
				temp.z = camera.z + 100;
				generate = int(random(30));
				if(generate == 1 || generate == 2 || generate == 3)//physic-ball
				{
					if(physikobject==0)
					{
						ent_create("jump_b.mdl",temp,bounce_ball);
					}
				}
				if(generate == 4 || generate == 5)//colored block
				{
					ent_create("box_b.mdl",temp,color_block);
				}
				if(generate == 6 || generate == 7)//darc-block
				{
					ent_create("box_b.mdl",temp,death_block);
				}
				if(generate == 8)
				{
					ent_create("diamond.mdl",temp,diamond);//diamond
				}
				if(generate == 9 || generate == 10)
				{
					if(int(random(3))==1)
					{
						ent_create("bigger.mdl",temp,bigger);
					}
					else
					{
						ent_create("smaller.mdl",temp,smaller);
					}
				}
				if(generate==11)
				{
					ent_create("box_b.mdl",temp,blitz_block);
				}
				if(generate>11)
				{
					if(generate > 30-level_nr/5)//bom+heart 
					{
						if(int(random(5))==1)
						{
							ent_create("heart.mdl",temp,heart);
						}
						else
						{
							ent_create("bomb.mdl",temp,bomb);
						}
					}
					else
					{
						ent_create("box_b.mdl",temp,box_normal);
					}
				}
				waitt ((max(32-level_nr,0)) + random(24)*time);
			}
			if(cheat_activ == 1)
			{
				temp.y = camera.x + (200-(random(400)));
				temp.x = camera.y + (200-(random(400)));
				temp.z = camera.z + 100;
				ent_create("box_b.mdl",temp,superbox);
				waitt(2*time);
			}
		}
		wait(1);
   }
}

function control_health
{
	me = player;
	var change_test;
	while(1)
	{
		if(score_points < 0)
		{
			lives -= 1;
			score_points = 0;
		}
		lives = clamp(lives,0,5);
		if(change_test != lives)
		{
			show_live = ((5-lives)*63);
			health_pan2.pos_x = screen_size.x - ((lives*63)+91);
			health_pan1.pos_x = screen_size.x - ((lives*63)+ 187);
			media_tune(bg_sound_handle,100-(2-min(2,lives))*50+1,0,0);
			if(lives<2)
			{
				snd_tune(bg_heartbeat,100,0,0);
			}
			else
			{
				snd_tune(bg_heartbeat,1,0,0);
			}
		}
		if(lives <= 0)
		{
			gameover = 1;
			pause = 1;
			game_over_txt.visible = on;
			game_over_txt.transparent = on;
			game_over_txt.alpha = 0;
			black_pan.alpha = 0;
			black_pan.visible = on;
			black_pan.transparent = on;
			while(game_over_txt.alpha < 100)
			{
				black_pan.alpha += 10*time;
				game_over_txt.alpha += 10*time;
				wait(1);
			}
			sleep(2);
			mouse_mode = 1;
			submit_pan.visible = on;
			submit_button_pan.visible = on;
			submit_name_txt.visible = on;
			while(submit_pan.alpha < 100)
			{
				submit_pan.alpha += 10*time;
				submit_button_pan.alpha += 10*time;
				submit_name_txt.alpha += 10*time;
				wait(1);
			}
			inkey_active = 0;
			//eingabe:
			inkey(playername);
			if(result == 27)
			{
				goto(restart);
			}
			black_pan2.alpha = 0;
			black_pan2.visible = on;
			black_pan2.transparent = on;
			abort_pan.alpha = 0;
			abort_pan.visible = on;
			abort_pan.transparent = on;
			//inkey_active = 0;
			post_score();
			while(abort_pan.alpha < 100)
			{
				black_pan2.alpha = min(black_pan2.alpha+25*time,92);
				abort_pan.alpha += 25*time;
				wait(1);
			}
			while(HTTP_IsWorking(0)==1)
			{
				waitt(16);
			}
			HTTP_Free(0);
			while(abort_pan.alpha > 0)
			{
				black_pan2.alpha -= 25*time;
				abort_pan.alpha -= 25*time;
				submit_pan.alpha -= 25*time;
				submit_button_pan.alpha -= 25*time;
				submit_name_txt.alpha -= 25*time;
				wait(1);
			}
			dll_close(dll_handle);
			black_pan2.alpha = 0;
			abort_pan.alpha = 0;
			black_pan2.visible = off;
			abort_pan.visible = off;
			sleep(2);
			visit_score();
			restart:
			file_handle = file_open_read("bonus1.dat");
			if(file_handle!=0)
			{
				temp = file_var_read(file_handle);temp*=7;temp/=3;temp-=12345;
				if(temp<level_nr*score_points&&cheater==0)
				{
					bonus_level=1;
					temp=1;//write
				}
				else
				{
					bonus_level=0;
					temp=0;//not write
				}
			}
			else
			{
				temp=1;//write
			}
			file_close(file_handle);
			if(temp==1)
			{
				file_handle=file_open_write("bonus1.dat");
				file_var_write(file_handle,(level_nr*score_points+12345)*3/7);
				file_close(file_handle);
			}
			while(key_any==0){wait(1);}
			restart();
			return;
		}
		change_test = lives;
		wait(1);
	}
}

function window_ctrl
{
	while(1)
	{
		if(video_screen == 2)
		{
			error("the game can't run in window-mode, sorry ;)");
			video_switch(0,0,1);
		}
		wait(1);
	}
}

string temp_string;
string score_string;

function post_score
{
	dll_handle = dll_open("GSHTTP.dll");
	if (HTTP_Create(0)==0)
	{
		str_cpy(temp_string,"name=");
		str_cat(temp_string,playername);
		str_cat(temp_string,"&score=");
		str_for_num(score_string,score_points);
		str_cat(temp_string,score_string);
		str_cat(temp_string,"&cheater=");
		if(cheater)
		{
			str_cat(temp_string,"1");
		}
		else
		{
			str_cat(temp_string,"0");
		}
		PostString = temp_string;
		HTTP_Post(0,"http://scorpionweb.sc.funpic.de/Bloxx/highscore.php",PostString);
		//ResultString="                                                               ";
		//HTTP_Results(0,ResultString);
		//msg_show(ResultString,10);
	}
}

function visit_score
{ 
	dll_handle = dll_open ("Bigdll.dll");
	str_cpy(temp_string,"http://scorpionweb.sc.funpic.de/Bloxx/highscore.php?name=");
	str_cat(temp_string,playername);
	str_cat(temp_string,"&score=");
	str_for_num(score_string,score_points);
	str_cat(temp_string,score_string);
	DllOpenInternet(temp_string);
	dll_close(dll_handle); 
}

function visit_info
{
	dll_handle = dll_open("Bigdll.dll");
	DllOpenInternet("http://scorpionweb.sc.funpic.de/Bloxx/info.php");
	dll_close(dll_handle);
}

function reset_panels
{
	game_over_txt.alpha = 0;
	game_over_txt.transparent = off;
	game_over_txt.visible = off;
	abort_pan.alpha = 0;
	abort_pan.transparent = off;
	abort_pan.visible = off;
	black_pan.alpha = 0;
	black_pan.transparent = off;
	black_pan.visible = off;
	black_pan2.alpha = 0;
	black_pan2.transparent = off;
	black_pan2.visible = off;
	submit_button_pan.visible = off;
	submit_pan.visible = off;
	health_pan1.visible = off;
	health_pan1.alpha = 0;
	health_pan1.transparent = off;
	health_pan2.visible = off;
	health_pan2.alpha = 0;
	health_pan2.transparent = off;
	health_pan3.visible = off;
	health_pan3.alpha = 0;
	health_pan3.transparent = off;
	score_pan.visible = off;
	score_pan.alpha = 0;
	score_pan.transparent = off;
}

function reset_values
{
	level_nr = 1;
	score_points = 0;
	show_live = 126;
	lives = 3;
	physikobject = 0;
	pause = 0;
	gameover = 0;
	str_cpy(playername," ");
	mouse_mode = 0;
}

function control_menue
{
	var old_menue=0;
	while(1)
	{
		if(menue!=2&&key_esc)
		{
			menue=(menue==0);
			pause=menue;
			while(key_esc){wait(1);}
		}
		if(menue==0 && key_p)
		{
			pause=(pause==0);
			while(key_p){wait(1);}
		}
		if(menue!=0)
		{
			pause=1;
		}
		//set the panels
		while(menue==3){wait(1);}
		if(menue<old_menue)//menue off
		{
			mouse_mode = 0;
			menue_pan.transparent = on;
			menue_ng_txt.transparent = on;
			menue_resume_txt.transparent = on;
			show_credits_txt.transparent = on;
			Exit_txt.transparent = on;
			help_pan.transparent = on;
			while(menue_pan.alpha>0)
			{
				menue_pan.alpha -= 10*time;
				if(old_menue==2)
				{
					menue_ng_txt.alpha -= 10*time;
				}
				else
				{
					menue_resume_txt.alpha -= 10*time;
				}
				show_credits_txt.alpha -= 10*time;
				Exit_txt.alpha -= 10*time;
				help_pan.alpha -= 10*time;
				wait(1);
			}
			menue_pan.visible = off;
			menue_ng_txt.visible = off;
			menue_resume_txt.visible = off;
			show_credits_txt.visible = off;
			Exit_txt.visible = off;
			help_pan.visible = off;
		}
		if(menue>old_menue)//menue on
		{
			while(player==null){wait(1);}
			vec_set(temp,player.x);
			vec_to_Screen(temp,camera);
			mouse_pos.x = temp.x;
			mouse_pos.y = temp.y;
			menue_pan.visible = on;
			if(menue==2)
			{
				menue_ng_txt.visible = on;
			}
			else
			{
				menue_resume_txt.visible = on;
			}
			show_credits_txt.visible = on;
			Exit_txt.visible = on;
			help_pan.visible = on;
			while(menue_pan.alpha<100)
			{
				menue_pan.alpha += 5*time;
				if(menue==2)
				{
					menue_ng_txt.alpha += 5*time;
				}
				else
				{
					menue_resume_txt.alpha += 5*time;
				}
				show_credits_txt.alpha += 5*time;
				Exit_txt.alpha += 5*time;
				help_pan.alpha += 5*time;
				wait(1);
			}
			menue_pan.transparent = off;
			menue_ng_txt.transparent = off;
			menue_resume_txt.transparent = off;
			show_credits_txt.transparent = off;
			Exit_txt.transparent = off;
			help_pan.transparent = off;
			mouse_mode = 2;
		}
		old_menue = menue;
		wait(1);
	}
}

function panel_position
{
	cheat_txt.pos_y  = screen_size.y - 20;
	health_pan3.pos_x = screen_size.x - 91;
	health_pan2.pos_x = screen_size.x - 280;
	health_pan1.pos_x = screen_size.x - 376;
	game_over_txt.pos_x = random(800);
	game_over_txt.pos_y = random(600);
	submit_pan.pos_x = (screen_size.x - 588)/2;
	submit_pan.pos_y = (screen_size.y - 229)/2-192;
	submit_name_txt.pos_x = submit_pan.pos_x + 90;
	submit_name_txt.pos_y = submit_pan.pos_y + 68;
	submit_button_pan.pos_x = submit_pan.pos_x + 139;
	submit_button_pan.pos_y = submit_pan.pos_y + 250;
	abort_pan.pos_x = (screen_size.x - 300)/2;
	abort_pan.pos_y = (screen_size.y - 50)/2 - 200;
	menue_pan.pos_x = (screen_size.x - 391)/2;
	menue_pan.pos_y = (screen_size.y - 550)/2;
	menue_ng_txt.pos_x = menue_pan.pos_x+40;
	menue_ng_txt.pos_y = menue_pan.pos_y+30;
	menue_resume_txt.pos_x = menue_pan.pos_x+40;
	menue_resume_txt.pos_y = menue_pan.pos_y+30;
	show_credits_txt.pos_x = menue_pan.pos_x+110;
	show_credits_txt.pos_y = menue_pan.pos_y+230;
	Exit_txt.pos_x = menue_pan.pos_x+200;
	Exit_txt.pos_y = menue_pan.pos_y+430;
	help_pan.pos_y = screen_size.y-70;
}

function flash_panel(color)//0=red/1=green
{
	me=null;
	window_flash_pan.visible = on;
	window_flash_pan.transparent = on;
	window_flash_pan.alpha = 100;
	if(!color)
	{
		window_flash_pan.red = 255;
		window_flash_pan.green = 0;
		window_flash_pan.blue = 0;
	}
	else
	{
		window_flash_pan.red = 0;
		window_flash_pan.green = 255;
		window_flash_pan.blue = 0;
	}
	while(window_flash_pan.alpha < 50)
	{
		window_flash_pan.alpha += 25*time;
		wait(1);
	}
	while(window_flash_pan.alpha > 0)
	{
		window_flash_pan.alpha -= 10*time;
		wait(1);
	}
	window_flash_pan.visible = off;
	window_flash_pan.transparent = off;
}

function make_it4shader
{
	while(1)
	{
		proc_late();
		you=ent_next(null);
		while(you!=null)
		{
			if(your.material==mtl_toon)
			{
				your.skill44 = float(your.alpha/100);
			}
			you=ent_next(you);
		}
		wait(1);
	}
}
///////////////////
//  E V E N T S  //
///////////////////

function glimmer_spiral(obj_x,obj_y,obj_z)
{
	me=null;
	var i=0;
	while(i<1800)
	{
		effect(glimmer,1,vector(obj_x-25*cos(i),obj_y-25*sin(i),obj_z+i/2),vector(0,0,-random(10)-1));
		i+=10;
		wait(-0.01);
	}
}

function block_normal_event
{
	my.passable = on;
	my.position = 0;
	if(event_type == event_entity || event_type == event_impact)
	{
		my.event = null;
		snd_play(plop1,100,0);
		
		effect(get_standart_part,30,my.x,null);
		if(my.skill2 == 1)
		{
			score_points += 100;
		}
		else
		{
			if(my.skin == 1)
			{
				score_points += 20;
				ent_create("20.tga",my.x,good_point);
			}
			else
			{
				score_points += 10;
				ent_create("10.tga",my.x,good_point);
			}
			wait(1);
		}
		while(my.alpha > 0)
		{
			my.alpha-=25*time;
			wait(1);
		}
		wait(1);
	}
}

function superbox_destroy
{
	effect(get_standart_part,30,my.x,null);
	score_points += 100;
	wait(1);
	ent_remove(me);
}

function bomb_event
{
	if(event_type == event_entity || event_type == event_impact)
	{
		if(you == player || your.skill5 == 2)
		{
			my.passable = on;
			my.position = 0;
			my.event = null;
			snd_play(explosion,100,0);
			effect(bomb_burn,400,my.x,null);
			effect(smoke,10,my.x,null);
			flash_panel(0);
			lives -= 1;
			while(my.alpha > 0)
			{
				my.alpha -= 25*time;
				wait(1);
			}
		}
	}
}

function heart_event
{
	if(event_type == event_entity || event_type == event_impact)
	{
		if(you == player || your.skill5 == 2)
		{
			my.passable = on;
			my.position = 0;
			my.event = null;
			if(lives < 5)
			{
				flash_panel(1);
				lives += 1;
			}
			else
			{
				score_points+=10;
				ent_create("10.tga",my.x,good_point);
			}
			my.alpha = 100;
			while(my.alpha > 0)
			{
				my.alpha -= 25*time;
				wait(1);
			}
		}
	}
}

function bounce_wave
{
	my.scale_x = 0.25;
	my.scale_y = 0.25;
	my.oriented = on;
	my.tilt = 90;
	my.transparent = on;
	my.unlit = on;
	my.ambient = 100;
	my.passable = on;
	while(1)
	{
		my.scale_x += 0.1*time;
		my.scale_y += 0.1*time;
		my.alpha -= 10*time;
		if(my.alpha<0)
		{
			ent_remove(me);
			return;
		}
		wait(1);
	}
}

function bounce_event
{
	if(event_type == event_entity || event_type == event_impact)
	{
		if(you==player || your.skill5 == 2)
		{
			my.event = null;
			ent_create("wave.tga",vector(my.x,my.y,my.z-20),bounce_wave);
			if(random(2)>1)
			{
				snd_play(boing1,100,0);
			}
			else
			{
				snd_play(boing2,100,0);
			}
			if(my.skill1 >= 2)
			{
				score_points += 50;
				ent_create("50.tga",my.x,good_point);
				while(my.alpha > 0)
				{
					my.alpha -= 25*time;
					wait(1);
				}
			}
			else
			{
				my.skill1 += 1;
			}
			waitt(3);
			my.event = bounce_event;
		}
	}
}

function color_block_event
{
	my.passable = on;
	my.position = 0;
	if(event_type == event_entity || event_type == event_impact)
	{
		my.event = null;
		snd_play(plop1,100,0);
		score_points+=20;
		ent_create("20.tga",my.x,good_point);
		my.alpha = 100;
		while(my.alpha > 0)
		{
			my.alpha -= 25*time;
			wait(1);
		}
	}
}

function death_block_event
{
	my.passable = on;
	my.position = 0;
	if(event_type == event_entity || event_type == event_impact)
	{
		my.event = null;
		snd_play(baad,100,0);
		score_points-=20;
		ent_create("m20.tga",my.x,bad_point);
		my.alpha = 100;
		while(my.alpha > 0)
		{
			my.alpha -= 25*time;
			wait(1);
		}
	}
}

function diamond_event
{
	my.passable = on;
	my.position = 0;
	if(event_type == event_entity || event_type == event_impact)
	{
		my.event = null;
		my.skill2 = 0;
		snd_play(ring,100,0);
		glimmer_spiral(my.x,my.y,my.z);
		while(my.alpha > 0)
		{
			my.alpha -= 25*time;
			wait(1);
		}
	}
}

function submit_fun
{
	inkey_active = 0;
}

function make_bigger
{
	player_size = 180;
	me = ent_create("player_b1.wmb",player.x,player_bigger);
	my.alpha=0;
	while(my.alpha<100)
	{
		if(player.x > -180 && player.x < 180 && player.y > -180 && player.y < 180)
		{
			my.alpha+=10*time;
		}
		wait(1);
	}
	ent_morph(player,"player_b1.wmb");
	ent_morph(my,"player_b2.wmb");
	my.alpha=0;
	while(player.x < -180 || player.x > 180 || player.y < -180 || player.y > 180){wait(1);}
	c_setminmax(player);
	while(my.alpha<100)
	{
		if(player.x > -180 && player.x < 180 && player.y > -180 && player.y < 180)
		{
			my.alpha+=10*time;
		}
		wait(1);
	}
	ent_morph(player,"player_b2.wmb");
	ent_remove(me);
	while(player.x < -180 || player.x > 180 || player.y < -180 || player.y > 180){wait(1);}
	c_setminmax(player);
	while(player_size>1)
	{
		player_size -= time;
		wait(1);
	}	
	me = ent_create("player_b2.wmb",player.x,player_bigger);
	ent_morph(player,"player_b1.wmb");
	my.alpha=100;
	while(my.alpha>0)
	{
		if(player.x > -180 && player.x < 180 && player.y > -180 && player.y < 180)
		{
			my.alpha-=10*time;
		}
		wait(1);
	}
	ent_morph(me,"player_b1.wmb");
	ent_morph(player,"player.wmb");
	my.alpha=100;
	while(player.x < -180 || player.x > 180 || player.y < -180 || player.y > 180){wait(1);}
	c_setminmax(player);
	while(my.alpha>0)
	{
		if(player.x > -180 && player.x < 180 && player.y > -180 && player.y < 180)
		{
			my.alpha-=10*time;
		}
		wait(1);
	}
	ent_remove(me);
	player_size=0;
}

function bigger_event
{
	my.passable = on;
	my.position = 0;
	if(event_type == event_entity || event_type == event_impact)
	{
		my.event = null;
		if(player_size==0)
		{
			make_bigger();
		}
		if(player_size>0)
		{
			player_size=180;
		}
		if(player_size<0)
		{
			player_size = -1;
		}
		snd_play(big,100,0);
		while(my.alpha>0)
		{
			my.alpha-=25*time;
			wait(1);
		}
	}
}

function make_smaller
{
	player_size = -180;
	me = ent_create("player.wmb",player.x,player_bigger);
	my.alpha=100;
	ent_morph(player,"player_s1.wmb");
	while(my.alpha>0)
	{
		if(player.x > -180 && player.x < 180 && player.y > -180 && player.y < 180)
		{
			my.alpha-=10*time;
		}
		wait(1);
	}
	ent_morph(player,"player_s2.wmb");
	ent_morph(my,"player_s1.wmb");
	my.alpha=100;
	while(player.x < -180 || player.x > 180 || player.y < -180 || player.y > 180){wait(1);}
	c_setminmax(player);
	while(my.alpha>0)
	{
		if(player.x > -180 && player.x < 180 && player.y > -180 && player.y < 180)
		{
			my.alpha-=10*time;
		}
		wait(1);
	}
	ent_remove(me);
	while(player_size<-1)
	{
		player_size += time;
		wait(1);
	}	
	me = ent_create("player_s1.wmb",player.x,player_bigger);
	my.alpha=0;
	while(my.alpha<100)
	{
		if(player.x > -180 && player.x < 180 && player.y > -180 && player.y < 180)
		{
			my.alpha+=10*time;
		}
		wait(1);
	}
	ent_morph(me,"player.wmb");
	ent_morph(player,"player_s1.wmb");
	my.alpha=0;
	while(player.x < -180 || player.x > 180 || player.y < -180 || player.y > 180){wait(1);}
	c_setminmax(player);
	while(my.alpha<100)
	{
		if(player.x > -180 && player.x < 180 && player.y > -180 && player.y < 180)
		{
			my.alpha+=10*time;
		}
		wait(1);
	}
	ent_morph(player,"player.wmb");
	ent_remove(me);
	player_size=0;
}

function smaller_event
{
	my.passable = on;
	my.position = 0;
	if(event_type == event_entity || event_type == event_impact)
	{
		my.event = null;
		if(player_size==0)
		{
			make_smaller();
		}
		if(player_size>0)
		{
			player_size=1;
		}
		if(player_size<0)
		{
			player_size=-180;
		}
		snd_play(small,100,0);
		while(my.alpha>0)
		{
			my.alpha-=25*time;
			wait(1);
		}
	}
}

function sack_event
{
	if(event_type==event_block)
	{
		my.passable=on;
		while(my.alpha>0)
		{
			my.alpha-=25*time;
			wait(1);
		}
		wait(1);
		ent_remove(me);
	}
	if(event_type==event_entity||event_type==event_impact)
	{
		my.skill1=0;
		if(you==player)
		{
			score_points+=50;
			ent_create("50.tga",my.x,good_point);
			my.skill2=0;
			my.passable=on;
			while(my.alpha>0)
			{
				my.alpha-=25*time;
				wait(1);
			}
			ent_remove(me);
		}
		else
		{
			my.skill2=-20;
		}
	}
}

function blitz_block_event
{
	my.passable = on;
	my.position = 0;
	if(event_type==event_impact||event_type==event_entity)
	{
		my.event = null;
		activate_laser(10);
		while(my.alpha>0)
		{
			my.alpha -= 25*time;
			wait(1);
		}
	}
}
//////////////////////////////////////
//  O B J E C T  F U N C T I O N S  //
//////////////////////////////////////

function box_normal
{
	my.enable_entity = on;
	my.enable_impact = on;
	my.event = block_normal_event;
	//my.unlit=on;
	my.skin = int(random(4))+1;
	if(my.skin==1)
	{
		my.alpha = 10;
		my.transparent = on;
	}
	else
	{
		my.alpha=100;
		my.material=mtl_toon;
	}
	my.skill1 = random(4)+2;
	my.position = -(random(5)+(level_nr*1.5));
	wait(1);
	c_setminmax(me);
	while(my.alpha > 0)
	{
		if(!pause)
		{
			c_move(me,nullvector,vector(0,0,my.position),glide);
			if(my.z < 335)
			{
				my.alpha -= 5*time;
			}
			if(my.z<-770)
			{
				my.event = null;
			}
			my.pan += my.skill1*time;
			my.tilt += my.skill1*time;
		}
		wait(1);
	}
	ent_remove(me);
}

function superbox
{
	my.enable_entity = on;
	my.event = superbox_destroy;
	my.enable_impact = on;
	my.unlit=on;
	my.skin = 1;
	my.invisible = on;
	my.skill2 = 1;
	my.red = random(255);
	my.green = random(255);
	my.blue = random(255);
	my.lightrange = 100;
	my.position = -(random(5)+(level_nr*1.5));
	wait(1);
	c_setminmax(me);
	while(my.z > 335)
	{
		c_move(me,nullvector,vector(0,0,my.position),glide);
		wait(1);
	}
	if(my.z<-770)
	{
		my.event = null;
	}
	superbox_destroy();
}

function bomb
{
	my.material=mtl_toon;
	my.metal = on;
	my.enable_entity = on;
	my.enable_impact = on;
	my.event = bomb_event;
	my.alpha = 100;
	my.unlit=on;
	my.position = -(random(5)+(level_nr*1.5));
	my.skill1 = random(4)+2;
	wait(1);
	c_setminmax(me);
	while(my.alpha > 0)
	{
		if(!pause)
		{
			c_move(me,nullvector,vector(0,0,my.position),glide);
			if(my.z < 335)
			{
				my.alpha -= 5*time;
			}
			if(my.z<-770)
			{
				my.event = null;
			}
			my.pan += my.skill1*time;
			my.tilt += my.skill1*time;
			vec_for_vertex(temp,me,111);
		}
		effect(bomb_burn,10*time,temp,null);
		wait(1);
	}
	ent_remove(me);	
}

action move_player
{
	var movement[3] = 0,0,0;
	player = me;
	c_setminmax(me);
	while(1)
	{
		//position.y = 30 * (min(mouse_force.x,20)) * time * -1;
		//position.x = 30 * (min(mouse_force.y,20)) * time;
		movement.y = mouse_speed * -mouse_force.x * time * inverse;
		movement.x = mouse_speed * mouse_force.y * time * inverse;
		//position.x = max(min(position.x,200),-200);
		//position.y = max(min(position.y,200),-200);
		c_move(me,nullvector,movement,glide);
		wait(1);
	}
}

function heart
{
	my.material=mtl_toon;
	my.enable_entity = on;
	my.enable_impact = on;
	my.event = heart_event;
	my.unlit=on;
	my.alpha = 100;
	my.skill1 = random(4)+2;
	my.position = -(random(5)+(level_nr*1.5));
	wait(1);
	c_setminmax(me);
	while(my.alpha > 0)
	{
		if(!pause)
		{
			c_move(me,nullvector,vector(0,0,my.position),glide);
			if(my.z < 335)
			{
				my.alpha -= 5*time;
			}
			if(my.z<-770)
			{
				my.event = null;
			}
			my.pan += my.skill1*time;
			my.tilt += my.skill1*time;
		}
		wait(1);
	}
	ent_remove(me);
}

function bounce_ball
{
	var physic = 1;
	physikobject +=1;
	my.material=mtl_toon;
	my.skin = int(random(2))+1;
	my.enable_entity = on;
	my.enable_impact = on;
	my.event = bounce_event;
	my.unlit = on;
	my.alpha = 100;
	phent_settype(my, PH_RIGID, PH_SPHERE);
	phent_setmass(my, 4, PH_SPHERE);
	phent_setfriction(my, 10);         
	phent_setelasticity(my,80,0);
	phent_setdamping(my, 0, 0);
	while(my.alpha > 0)
	{
		if(!pause)
		{
			if(!physic)
			{
				phent_settype(my, PH_RIGID, PH_SPHERE);
				physic+=1;
			}
			if(my.z < 300)
			{
				my.alpha -= 5*time;
			}
			if(my.z<-770)
			{
				my.event = null;
			}
		}
		else
		{
			if(physic==1)
			{
				phent_settype(my, 0, 0);
				physic -= 1;
			}
		}
		wait(1);
	}
	physikobject -=1;
	ent_remove(me);
}

function laser_animate
{
	while(1)
	{
		if(my.frame >= 4)
		{
			my.frame = 1;
		}
		my.frame += 1*time;
		wait(1);
	}
}

action laser
{
	my.skill5 = 2;//this is a LASER
	laser_animate();
	my.alpha = 0;
	my.transparent = on;
	wait(1);
	c_setminmax(me);
	if(my.pan == 270)
	{
		if(int(random(2))==1){goto(1a);}
		else{goto(1b);}
		while(1)
		{
			if(laser_on == 1)
			{
				my.invisible = off;
				my.passable = off;
				if(my.alpha < 100)
				{
					my.alpha += 10*time;
				}
				1a:
				while(laser_on==1 && my.x>-200)
				{
					if(my.alpha < 100)
					{
						my.alpha += 10*time;
					}
					my.x -= 5*time;
					wait(1);
				}
				1b:
				while(laser_on==1 && my.x<200)
				{
					if(my.alpha < 100)
					{
						my.alpha += 10*time;
					}
					my.x += 5*time;
					wait(1);
				}
			}
			else
			{
				my.invisible = on;
				my.passable = on;
			}
			wait(1);
		}
	}
	else
	{
		if(int(random(2))==1){goto(2a);}
		else{goto(2b);}
		while(1)
		{
			if(laser_on == 1)
			{
				my.invisible = off;
				my.passable = off;
				if(my.alpha < 100)
				{
					my.alpha += 10*time;
				}
				2a:
				while(laser_on==1 && my.y>-200)
				{
					if(my.alpha < 100)
					{
						my.alpha += 10*time;
					}
					my.y -= 5*time;
					wait(1);
				}
				2b:
				while(laser_on==1 && my.y<200)
				{
					if(my.alpha < 100)
					{
						my.alpha += 10*time;
					}
					my.y += 5*time;
					wait(1);
				}
			}
			else
			{
				if(my.alpha > 0)
				{
					my.alpha -= 10*time;
				}
				my.invisible = on;
				my.passable = on;
			}
			wait(1);
		}
	}
}

function color_change_red
{
	while(1)
	{
		while(my.red<255)
		{
			my.red = min(my.red+random(50)*time,255);
			wait(1);
		}
		while(my.red>0)
		{
			my.red = max(my.red-random(50)*time,0);
			wait(1);
		}
		wait(1);
	}
}

function color_change_green
{
	while(1)
	{
		while(my.green<255)
		{
			my.green = min(my.green+random(50)*time,255);
			wait(1);
		}
		while(my.green>0)
		{
			my.green = max(my.green-random(50)*time,0);
			wait(1);
		}
		wait(1);
	}
}

function color_change_blue
{
	while(1)
	{
		while(my.blue<255)
		{
			my.blue = min(my.blue+random(50)*time,255);
			wait(1);
		}
		while(my.blue>0)
		{
			my.blue = max(my.blue-random(50)*time,0);
			wait(1);
		}
		wait(1);
	}
}

function color_block
{
	my.material=mtl_toon;
	my.light = on;
	my.enable_entity = on;
	my.enable_impact = on;
	my.event = color_block_event;
	my.unlit=on;
	my.skin = 1;
	my.alpha=100;
	randomize();
	my.skill1 = random(4)+2;
	my.red = random(255);
	my.green = random(255);
	my.blue = random(255);
	my.position = -(random(5)+(level_nr*1.5));
	color_change_red();
	color_change_green();
	color_change_blue();
	wait(1);
	c_setminmax(me);
	while(my.alpha > 0)
	{
		if(!pause)
		{
			c_move(me,nullvector,vector(0,0,my.position),glide);
			if(my.z < 335)
			{
				my.alpha -= 5*time;
			}
			if(my.z<-770)
			{
				my.event = null;
			}
			my.pan += my.skill1*time;
			my.tilt += my.skill1*time;
		}
		wait(1);
	}
	ent_remove(me);
}

action rohr
{
	my.alpha=100;
	my.material=mtl_toon;	
	my.polygon = on;
	my.skill5 = 2;
}

function good_point
{
	my.passable = on;
	my.oriented = on;
	my.tilt += 90;
	my.pan = camera.pan+180;
	my.transparent=on;
	my.alpha=100;
	my.scale_x = 1.5;
	my.scale_y = 1.5;
	my.light = on;
	my.red = 0;
	my.green = 0;
	my.blue = 0;
	my.unlit = on;
	while(my.alpha>0)
	{
		my.alpha -= 2*time;
		my.green = min(my.green+10*time,255);
		my.z += 8*time;
		wait(1);
	}
	ent_remove(me);
}

function bad_point
{
	my.passable = on;
	my.oriented = on;
	my.tilt += 90;
	my.pan = camera.pan+180;
	my.transparent=on;
	my.alpha=100;
	my.scale_x = 1.5;
	my.scale_y = 1.5;
	my.light = on;
	my.red = 0;
	my.green = 0;
	my.blue = 0;
	my.unlit = on;
	while(my.alpha>0)
	{
		my.alpha -= 2*time;
		my.red = min(my.red+10*time,255);
		my.z += 8*time;
		wait(1);
	}
	ent_remove(me);
}

function smog
{
	my.scale_x = 2;
	my.scale_y = 2;
	my.tilt = 90;
	my.oriented = on;
	my.unlit = on;
	my.ambient = 100;
	my.transparent = on;
	my.passable = on;
	while(1)
	{
		if(you==null)
		{
			while(my.alpha>0)
			{
				my.alpha -= 5*time;
				wait(1);
			}
			ent_remove(me);
			return;
		}
		else
		{
			vec_set(my.x,your.x);
			my.z -= 100;
		}
		my.scale_x += 0.2*time;
		my.scale_y += 0.2*time;
		my.alpha -= 10*time;
		if(my.scale_x>2.5)
		{
			my.scale_x = 0.125;
			my.scale_y = 0.125;
			my.alpha = 100;
		}
		wait(1);
	}
}

function death_block
{
	my.material=mtl_toon;
	my.light = on;
	my.enable_entity = on;
	my.enable_impact = on;
	my.event = death_block_event;
	my.unlit=on;
	if(level_nr<5)
	{
		my.skin=5;
	}
	else
	{
		my.skin = int(min(random(level_nr)*0.5,5));
	}
	my.alpha=100;
	my.skill1 = random(4)+2;
	my.position = -(random(5)+(level_nr*1.5));
	ent_create("smog.tga",my.x,smog);
	wait(1);
	c_setminmax(me);
	while(my.alpha > 0)
	{
		if(!pause)
		{
			c_move(me,nullvector,vector(0,0,my.position),glide);
			if(my.z < 335)
			{
				my.alpha -= 5*time;
			}
			if(my.z<-770)
			{
				my.event = null;
			}
			my.pan += my.skill1*time;
			my.tilt += my.skill1*time;
		}
		wait(1);
	}
	ent_remove(me);
}


function diamond
{
	my.material=mtl_toon;
	my.enable_entity = on;
	my.enable_impact = on;
	my.event = diamond_event;
	my.unlit=on;
	my.alpha=50;
	my.skill1 = random(4)+2;
	my.skill2 = 1;
	my.position = -(random(5)+(level_nr*1.5));
	wait(1);
	c_setminmax(me);
	while(my.alpha > 0)
	{
		if(!pause)
		{
			c_move(me,nullvector,vector(0,0,my.position),glide);
			if(my.z < 335)
			{
				my.alpha -= 5*time;
			}
			if(my.z<-770)
			{
				my.event = null;
			}
			my.pan += my.skill1*time;
			my.tilt += my.skill1*time;
		}
		temp.x = my.x+20-random(40);
		temp.y = my.y+20-random(40);
		temp.z = my.z+10-random(20);
		effect(glimmer,1,temp,vector(0,0,random(7)+1));
		wait(1);
	}
	if(my.skill2==1)
	{
		lives -= 1;
		flash_panel(0);
		snd_play(groll,100,0);
	}
	ent_remove(me);
}

function bigger
{
	var animate;
	my.material=mtl_toon;
	my.enable_entity = on;
	my.enable_impact = on;
	my.event = bigger_event;
	my.unlit=on;
	my.alpha=100;
	my.skill1=random(4)+2;
	my.position = -(random(5)+(level_nr*1.5));
	while(my.alpha>0)
	{
		if(!pause)
		{
			animate+=10*time;
			//animate %= 100;
			ent_animate(me,"Frame",animate,anm_cycle);
			c_move(me,nullvector,vector(0,0,my.position),glide);
			if(my.z < 335)
			{
				my.alpha -= 5*time;
			}
			if(my.z<-770)
			{
				my.event = null;
			}
			my.pan += my.skill1*time;
			my.tilt += my.skill1*time;
		}
		wait(1);
	}
	ent_remove(me);
}

function player_bigger
{
	my.passable=on;
	my.transparent=on;
	while(1)
	{
		proc_late();
		vec_set(my.x,player.x);
		wait(1);
	}
}

function smaller
{
	var animate;
	my.material=mtl_toon;
	my.enable_entity = on;
	my.enable_impact = on;
	my.event = smaller_event;
	my.unlit=on;
	my.alpha=100;
	my.skill1=random(4)+2;
	my.position = -(random(5)+(level_nr*1.5));
	while(my.alpha>0)
	{
		if(!pause)
		{
			animate+=10*time;
			//animate %= 100;
			ent_animate(me,"Frame",animate,anm_cycle);
			c_move(me,nullvector,vector(0,0,my.position),glide);
			if(my.z < 335)
			{
				my.alpha -= 5*time;
			}
			if(my.z<-770)
			{
				my.event = null;
			}
			my.pan += my.skill1*time;
			my.tilt += my.skill1*time;
		}
		wait(1);
	}
	ent_remove(me);
}

function sack
{
	my.material=mtl_toon;
	my.push = -1;
	my.skill5 = 2;
	my.enable_block = on;
	my.enable_entity = on;
	my.enable_impact = on;
	my.event = sack_event;
	my.pan=your.pan;
	my.skill1=5;
	my.skill2=0;
	my.alpha=100;
	while(1)
	{
		vec_set(temp,vector(my.skill1,0,my.skill2));
		vec_scale(temp,time);
		c_move(me,temp,nullvector,null);
		wait(1);
	}
}

action create_sack
{
	my.passable = on;
	while(1)
	{
		ent_create("sack.mdl",my.x,sack);
		waitt(24+random(32));
	}
}

function blitz
{
	var distance = 20;
	var parent_pos[3];
	my.transparent = on;
	my.passable = on;
	my.oriented = on;
	my.alpha = 100;
	my.unlit = on;
	my.ambient = 100;
	my.pan = random(360);
	my.tilt = random(360);
	my.red = 0;
	my.green = 0;
	my.blue = 255;
	my.light = on;
	while(my.alpha>0)
	{
		if(you!=null)
		{
			vec_set(parent_pos,your.x);
		}
		my.x = parent_pos.x - fcos(my.pan,distance)*sin(my.tilt);
		my.y = parent_pos.y - fsin(my.pan,distance)*sin(my.tilt);
		my.z = parent_pos.z - fcos(my.tilt,distance);
		my.scale_y += 0.5*time;
		my.alpha -= 30*time;
		wait(1);
	}
	ent_remove(me);
}

function emit_blitz
{
	while(1)
	{
		ent_create("blitz.tga",my.x,blitz);
		wait(-random(0.125));
	}
}

function blitz_block
{
	my.material=mtl_toon;
	my.enable_entity = on;
	my.enable_impact = on;
	my.event = blitz_block_event;
	my.unlit = on;
	my.alpha = 60;
	my.skill1 = random(4)+2;
	my.position = -(random(5)+(level_nr*1.5));
	emit_blitz();
	while(my.alpha>0)
	{
		if(!pause)
		{
			c_move(me,nullvector,vector(0,0,my.position),glide);
			if(my.z < 335)
			{
				my.alpha -= 5*time;
			}
			my.pan += my.skill1*time;
			my.tilt += my.skill1*time;
		}
		wait(1);
	}
	ent_remove(me);
}
//////////////////////
// P A R T I C L E  //
//////////////////////

function standart_fade
{
	my.alpha -= 5*time;
	//my.green -= 25*time;
	my.green = max(0,my.green-25*time);
	if(my.alpha < 0)
	{
		my.lifespan = 0;
	}
}

function get_standart_part
{
	my.size = 20;
	my.vel_x = 5-random(10);
	my.vel_y = 5-random(10);
	my.vel_z = random(2)+1;
	my.bmap = star;
	my.move = on;
	my.transparent = on;
	my.alpha = 60;
	my.function =  standart_fade;
	my.gravity = 1.2;
	my.red = 255;
	my.green = 255;
	my.blue = 0;
}

function funken_fade
{
	my.alpha -= 15*time;
	my.green = max(100,my.green-25*time);
	if(my.alpha < 0)
	{
		my.lifespan = 0;
	}
}

function bomb_burn
{
	my.size = 1;
	my.vel_x = 10-random(20);
	my.vel_y = 10-random(20);
	my.vel_z = 10-random(20);
	my.bmap = funke;
	my.move = on;
	my.transparent = on;
	my.alpha = 70;
	my.streak = on;
	my.function = funken_fade;
	my.red = 255;
	my.green = 121;
	my.bright = on;
	my.gravity = 1;
}

function smoke_fade
{
	my.alpha -= 1.5*time;
	my.red = min(my.red+10*time,255);
	//my.green = min(my.green+0.25*time,255);
	my.size+=2*time;
	if(my.alpha < 0)
	{
		my.lifespan = 0;
	}
}

function smoke
{
	my.size = 50;
	my.vel_x = 0.5-random(1);
	my.vel_y = 0.5-random(1);
	my.vel_z = 8-random(16);
	my.bmap = smoke_bmp;
	my.move = on;
	my.transparent = on;
	my.alpha = 60;
	my.bright = on;
	my.function = smoke_fade;
	if(int(random(2))==0)
	{
		my.red = 0;
		my.green = 0;
		my.blue = 0;
	}
	else
	{
		my.red = 30;
		my.green = 20;
		my.blue = 0;	
	}
}

function glimmer_fade
{
	my.alpha -= 5*time;
	my.size = random(5)+5;
	my.red = min(my.red+1*time,255);
	my.green = min(my.green+1*time,255);
	if(my.alpha < 0)
	{
		my.lifespan = 0;
	}
}

function glimmer
{
	my.size = random(5)+5;
	my.bmap = star;
	my.alpha = 30;
	my.bright = on;
	my.red = 50;
	my.green = 50;
	my.blue = 255;
	my.transparent = on;
	my.beam = on;
	my.function = glimmer_fade;
}

on_esc = null;